### tao_ifr User's Guide

### Overview

tao_ifr is TAO's interface repository loader. When executed, it will first resolve the interface repository, either by finding the interface repository's IOR in a file whose name is passed to it through the -ORBInitRef command line option, or by IP multicast (the default). Note - if the -ORBInitRef option is used, it should come first on the command line, since it will be consumed when the ORB is initialized. Then it will create entries in (or remove entries from) the repository corresponding to the declarations found in the IDL file(s) passed to it. If an entry to be removed is not found the repository, nothing happens. As stated elsewhere in the documentation, if an entry to be added is found to already exist in the repository (that is, if the interface repository id is found by lookup), the old entry will be replaced by the new one. It is the user's responsibility to make sure that no entries are unexpectedly replaced in the repository. This is also the method by which interfaces forward declared but not defined in one IDL file are fully defined in another. If the old and new entries are both interfaces, there is no way for tao_ifr to know if this is the intention, or if there is a genuine name clash. The behavior shown by tao_ifr in this case was chosen to conform to the behavior of the interface repository loaders from other ORB vendors.

### tao_ifr Command Line Options

tao_ifr uses the front end of the TAO IDL compiler, which invokes your `C` (or `C++`) preprocessor to resolve included IDL files. It receives the common options for preprocessors (such as `-D` or `-I`). It also receives other options that are specific to it

Option | Description | Remark
--- | --- | ---
`-ORBInitRef InterfaceRepository= corbaloc:iiop:[hostname]:[port]/InterfaceRepository` | Locate the Interface Repository using the Interoperable Naming Service | Without this option, the Interface Repository will be located by multicast.
`-ORBInitRef InterfaceRepository=file://[filename]` | Locate the Interface Repository using the IOR from a file. | Without this option, the Interface Repository will be located by multicast.
`-u` | Prints the options given below and exits. | Outputs to stdout by default.
`-v` | Traces tao_ifr processing stages. |
`-V` | Prints version information and exits. |
`-E` | Invokes the preprocessor and exits. | Outputs to stdout by default.
`-d` | Outputs a dump of the AST. | Outputs to stdout by default.
`-D` macro_definition | macro_definition is passed to the preprocessor. |
`-U` macro_name | macro_name is passed to the preprocessor. | Undefines macro_name.
`-I` include_path | include_path is passed to the preprocessor. |
`-A` assertion | assertion is passed to the preprocessor. | Local implementation-specific escape.
`-Yp,path` | Specifies the path for the preprocessor. |
`-t` directory_name | Temporary directory to be used by the IDL compiler. | Default: Resolve ACE_DEFAULT_TEMP_DIR_ENV. If it is not defined, /tmp/ is used.
`-Cw` | Output a warning if two identifiers in the same scope differ in spelling only by case. | Default is to output error message. This option has been added as a nicety for dealing with legacy IDL files, written when the CORBA rules for name resolution were not as stringent.
`-Ce` | Output an error if two indentifiers in the same scope differ in spelling only by case. | This will also happen by default.
`-w` | Suppress IDL compiler warning messages. |
`-Si` | Suppress processing of included IDL files. | Default is to process included IDL files.
`-L` | Enables locking at the IDL file level. | Guards against the same IDL file being processed concurrently by multiple threads running tao_ifr.
`-r` | Remove contents of IDL file(s) from the repository. | Default is to add contents.

Back to the Interface Repository documentation.